#include <iostream>
#include <math.h>
#include <iomanip>

using namespace std;


/*
 * Program to evaluate the sum in Exercise 1 (iii) of Blatt 10, QFT_2
 *   July 3, 2012
 * 
 * compile with:
 *       g++ lattice_harmonic_oscillator.cpp -o harmonic
 * run with:
 *       ./harmonic > output_file.dat
 * 
 * the output file contains two columns: tau(1), C*(2), where:
 *      tau = [ (k-j) * delta_t ] / T = (k-j)/N in [0,1]
 *      C*  = C(t) / T^2
 */

#define PI   (3.14159265358979)

// Constants
const double eta = 1.0; // eta = omega/m
const double mu  = 8.0; // mu = m T

const int    N   =   32; // number of points along T

int main(){

	// kj is "k-j"
	for(int kj=0;kj<=N;kj++){
		double cstar = 0.0;
		//perform the sum
		for(int n=1;n<=N;n++){
			double numerator   = cos(2.0*PI*n*kj / (1.0*N));
			double denominator = ((pow(eta*mu,2.0))/(1.0*N)) + 2.0*N*(1.0 - cos((2.0*PI*n)/(1.0*N)) );
			cstar += (1./(mu*N))*(numerator/denominator);
		}
		cout << ((kj*1.0)/(1.0*N)) << "\t" << std::setprecision(12) << cstar << endl;
	}
	
	return 0;
}
